
import userdb.*;
import java.sql.*;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;


class UnixUserServant extends UnixUserPOA
{
    ORB orb;
    POA userdbPOA;
    String dbUrl;
    String dbUser;
    String dbPassword;

    class State
    {
	String sid;
	String login;
	int    uid;
	int    gid;
	String name;
	String homedir;
	UnixUserStatus status;
    }

    State state;

    
    UnixUserServant (ORB orb, POA userdbPOA, String dbUrl,
	String dbUser, String dbPassword, State state)
    {
	this.orb = orb;
	this.userdbPOA = userdbPOA;
	this.dbUrl = dbUrl;
	this.dbUser = dbUser;
	this.dbPassword = dbPassword;
	this.state = state;
    }

    void checkState()
    {
	if (state == null)
	{
	    throw new org.omg.CORBA.UNKNOWN("state variable not set");
	}

        System.out.println(" accessing " + state.login);
    }

    public String sid() { checkState(); return state.sid; }
    public String login() { checkState(); return state.login; }
    public int uid() { checkState(); return state.uid; }
    public int gid() { checkState(); return state.gid; }
    public String name() { checkState(); return state.name; }
    public String homedir() { checkState(); return state.homedir; }
    public UnixUserStatus status() { checkState(); return state.status; }

    public void status(UnixUserStatus s)
    {
	checkState();
	state.status = s;


	if (state.sid.startsWith("MQ"))
	{
	    int status = 0;

	    if (s.equals(UnixUserStatus.NEW))
	    {
		status = 1;
	    }
	    else if (s.equals(UnixUserStatus.DENY_ACCESS))
	    {
		status = 9;
	    }
	    else if (s.equals(UnixUserStatus.READY))
	    {
		status = 10;
	    }



	    try
	    {
		Connection db = 
		    DriverManager.getConnection(dbUrl, dbUser, dbPassword);
		Statement stmt = db.createStatement();

	   	int ret = stmt.executeUpdate(
		 "UPDATE USERIDS SET status=" + status +
		   "WHERE sid='" + state.sid + "'");
		    
		if (ret != 1)
		{
		    throw new org.omg.CORBA.UNKNOWN("update problem");
		}

		stmt.close();
		db.close();
	    }
	    catch (Exception e)
	    {
		e.printStackTrace();
		throw new org.omg.CORBA.UNKNOWN("Database problem");
	    }
	}
	else
	{
	    System.out.println(" warning: status change for "+
		state.login + " not allowed..");

	    throw new org.omg.CORBA.NO_PERMISSION();
	}
    }
}

