

import userdb.*;

import org.omg.CORBA.ORB;
import org.omg.PortableServer.POA;
import org.omg.CosTransactions.*;


public class HomeDirCreatorImpl3 extends userdb.HomeDirCreatorPOA
{
    ORB orb;
    POA poa;
    java.util.Vector resources;

    public HomeDirCreatorImpl3 (ORB orb, POA poa)
    {
	this.orb = orb;
	this.poa = poa;
	resources = new java.util.Vector();
    }

    public void makeHomeDir (String homedir, int uid, int gid)
    {
	HomeDirCreatorResourceImpl r = getResource();

	if (r == null)
	{
	    throw new org.omg.CORBA.TRANSACTION_REQUIRED();
	}

	r.homedir = homedir;
	r.uid = uid;
	r.gid = gid;
    }

    void removeResource( HomeDirCreatorResourceImpl r )
    {
        resources.removeElement(r);
        try
        {   
            poa.deactivate_object(poa.servant_to_id(r));
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }


    HomeDirCreatorResourceImpl getResource ()
    {
        HomeDirCreatorResourceImpl hdcr = null;

        try
        {
            Current c = CurrentHelper.narrow(
                orb.resolve_initial_references("TransactionCurrent"));
            Control ctrl = c.get_control();

            if (ctrl == null)
            {
                hdcr = null; // keine Transaktion
            }
            else
            {
                Coordinator coord = ctrl.get_coordinator();

                for (int i=0; i < resources.size(); i++)
                {
                    HomeDirCreatorResourceImpl r =
		     (HomeDirCreatorResourceImpl) resources.elementAt(i);

                    if (coord.is_same_transaction(r.coordinator()))
                    {
                        hdcr = r;
                        break;
                    }
                }

                if (hdcr == null)
                {
                    hdcr = new HomeDirCreatorResourceImpl(this, coord);
                }

                HomeDirCreatorResource res = HomeDirCreatorResourceHelper.narrow(
                    poa.servant_to_reference(hdcr));

                try
                {
                    coord.register_resource(res);
                    resources.addElement(hdcr);
                }
                catch (org.omg.CORBA.TRANSACTION_ROLLEDBACK ex)
                {
                    poa.deactivate_object(poa.servant_to_id(hdcr));
                    throw ex;
                }
            }
        }
        catch (org.omg.CORBA.TRANSACTION_ROLLEDBACK ex)
        {
            throw ex;
        }
        catch (Exception e)
        {
            e.printStackTrace();
            hdcr = null;
        }

        return hdcr;
    }
}
