

import userdb.*;

import java.sql.*;
import org.omg.CosTransactions.*;


public class HomeDirCreatorResourceImpl extends HomeDirCreatorResourcePOA
{

    Coordinator myCoordinator;
    HomeDirCreatorImpl3 myServant;

    boolean errorOccurred;

    String homedir;
    int uid;
    int gid;


    Coordinator coordinator()
    {
	return myCoordinator;
    }

    public HomeDirCreatorResourceImpl (HomeDirCreatorImpl3 s, Coordinator c)
    {
	myServant = s;
	myCoordinator = c;
	errorOccurred = false;
    }



    public Vote prepare()
    {
	System.out.println("TRANSACTION prepare");

	System.out.println(" mkdir " + homedir);
        System.out.println(" chmod 700 " + homedir);
        System.out.println(" chown " + uid + " " + homedir);
        System.out.println(" chgrp " + gid + " " + homedir);

	// errorOccurred = true;

	if (errorOccurred)
	{
	    myServant.removeResource(this);
	    return Vote.VoteRollback;
	}
	else
	{
	    return Vote.VoteCommit;
	}
    }

    public void commit_one_phase()
    {
	System.out.println("TRANSACTION commit_one_phase");

	System.out.println(" mkdir " + homedir);
        System.out.println(" chmod 700 " + homedir);
        System.out.println(" chown " + uid + " " + homedir);
        System.out.println(" chgrp " + gid + " " + homedir);


	myServant.removeResource(this);
    }

    public void commit()
    {
	System.out.println("TRANSACTION commit");

	System.out.println(" # " + homedir + " schon angelegt.. alles ok");

	myServant.removeResource(this);
    }

    public void forget()
    {
	System.out.println("TRANSACTION forget");
	myServant.removeResource(this);
    }

    public void rollback()
    {
	System.out.println("TRANSACTION rollback");

	System.out.println(" rmdir " + homedir);

	myServant.removeResource(this);
    }



}
