


import userdb.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;



public class DBServer
{
	
    public static void main (String argv[])
    {
	try
	{
	    Class.forName("org.postgresql.Driver");
	    String dbUrl = "jdbc:postgresql:userdb";
	    String dbUser = "useradmin";
	    String dbPassword = "";

	    ORB orb = ORB.init(argv, null);

	    POA rootPOA = POAHelper.narrow(
		orb.resolve_initial_references("RootPOA"));


	    Policy policies[] = new Policy[7];

	    policies[0] = rootPOA.create_lifespan_policy(
		LifespanPolicyValue.PERSISTENT);

	    policies[1] = rootPOA.create_id_assignment_policy(
		IdAssignmentPolicyValue.USER_ID);

	    policies[2] = rootPOA.create_implicit_activation_policy(
		ImplicitActivationPolicyValue.NO_IMPLICIT_ACTIVATION);

	    policies[3] = rootPOA.create_servant_retention_policy(
		ServantRetentionPolicyValue.RETAIN);

	    policies[4] = rootPOA.create_request_processing_policy(
		RequestProcessingPolicyValue.USE_DEFAULT_SERVANT);

	    policies[5] = rootPOA.create_id_uniqueness_policy(
		IdUniquenessPolicyValue.MULTIPLE_ID);

	    policies[6] = rootPOA.create_thread_policy(
		ThreadPolicyValue.ORB_CTRL_MODEL); 

	    POA userdbPOA = rootPOA.create_POA("userdbPOA",
		rootPOA.the_POAManager(),
		policies);

	    
	    UnixUserDefaultServant defaultServant =
		new UnixUserDefaultServant (orb, userdbPOA, dbUrl, dbUser, dbPassword);

	    userdbPOA.set_servant(defaultServant);

	    NamingContextExt ctx = NamingContextExtHelper.narrow(
		orb.resolve_initial_references("NameService"));


	    UnixUserHomeImpl userHome =
		 new UnixUserHomeImpl (orb, userdbPOA, dbUrl, dbUser, dbPassword);

	    org.omg.CORBA.Object obj = rootPOA.servant_to_reference(userHome);

	    ctx.rebind( ctx.to_name("UnixUserHome"), obj);

	    rootPOA.the_POAManager().activate();

	    System.out.println("Server is ready.");

	    orb.run();

	}
	catch (Exception e)
	{
		e.printStackTrace();
	}

    }

}

