

import userdb.*;
import java.sql.*;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;



class UnixUserHomeImpl extends UnixUserHomePOA
{
    ORB orb;
    POA userdbPOA;
    String dbUrl;
    String dbUser;
    String dbPassword;

    UnixUserHomeImpl(ORB orb, POA userdbPOA, String dbUrl, String dbUser, String dbPassword)
    {
	this.orb = orb;
	this.userdbPOA = userdbPOA;
	this.dbUrl = dbUrl;
	this.dbUser = dbUser;
	this.dbPassword = dbPassword;

    }


    public ShortInfo[] get_user_list()
    {
	java.util.LinkedList list;
	list = new java.util.LinkedList();

	try
	{
            Statement stmt = db.createStatement();
	      
            ResultSet rs = stmt.executeQuery(
		 "SELECT sid, name, status FROM USERIDS");

	    while (rs.next())
	    {
		ShortInfo si = new ShortInfo();

		si.name = rs.getString("name");

		int stat = rs.getInt("status");

		switch(stat)
		{
		case 1:
		    si.status = UnixUserStatus.NEW;
		    break;
		case 9:
		    si.status = UnixUserStatus.DENY_ACCESS;
		    break;
		case 10:
		    si.status = UnixUserStatus.READY;
		    break;
		default:
		    si.status = UnixUserStatus.DELETED;
		    break;
		}

		si.theUser = UnixUserHelper.narrow(
		    userdbPOA.create_reference_with_id(
			rs.getString("sid").getBytes(),
			"IDL:userdb/UnixUser:1.0"));

		list.addLast(si);
	    }
	}
	catch (Exception e)
	{
	    e.printStackTrace();

	    throw new RuntimeException();
	}

	System.out.println("number of users: " + list.size());

	return (ShortInfo[]) list.toArray(new ShortInfo[0]);
    }
}

